$(document).ready(function() {
  // do stuff when DOM is ready

  // Insert a spacer for the zoom overlay 
  $(".pos:first").prepend('<div class="zoom"></div>');
				  
  // Make a POS number tab
  $(".posno").wrapInner('<div class="pos-tab" />');

  // Convert audio tags
  $(".au").each(function(index) {
    // Assign unique ids to all audio buttons  id="au0", id="au1", etc...
    var auID = "au" + index;

    // Convert internal href 'filename' to the form 'x-mw://play/id/filename'
    var auFilename = $(this).attr('href');
    var playbackURL = "x-mw://play/" + auID + "/" + auFilename;
    $(this).attr('id', auID);
    $(this).attr('href', playbackURL);
    
    // clear the DOM text
    $(this).text('');
  });
  
  //Handle links
  $("a").each(function(index) {

    if ($(this).attr('href').search(/\/table\/dict\/.*/) != -1) {
      // convert table/dict hrefs to normal text
      $(this).replaceWith($(this).contents());
    }
    else {
      // Add our own click handler
      $(this).click(function(e) {
        if ($(this).hasClass("au")) {
          // mark this element as playing and prevent further playback
          $(this).toggleClass("playing").unbind('click');
        }
        else {
          // disable normal handling of an A tag
          e.preventDefault();
        
          // Apply a temporary style to selected term for word click
          $(this).addClass("selected");

          // Callback to ObjC to lookup the selected term
          window.location.href = "x-mw://lookup/" + $(this).text();

          // After a small delay, unselect the term
          $(this).delay(800);
          $(this).queue( function() {
            $(this).removeClass("selected");
            $(this).dequeue();
          });
        }
      });
    }
  });
  
  // Add WordClick spans
  $("div.pos > div").not("div.hw,div.pron").each( function() {
   function applyWordClick(node) {
     var skip = 0;
     // Process text nodes except those that are embedded inside of an A tag
     if ((node.nodeType == 3) && (node.parentNode.tagName != 'A')) {
       // We are in a text node

       // Find first alphanumeric string including a hyphen ([a-zA-Z0-9\-]) with at least 4 characters
       var matched = node.data.match(/[a-zA-Z0-9\-]{4,}/);
       if (matched)
       {
         // Wrap word in a <span class="wc">
         var pos = matched.index;
         var spannode = document.createElement('span');
         spannode.className = 'wc';
         var middlebit = node.splitText(pos);
         var endbit = middlebit.splitText(matched[0].length);
         var middleclone = middlebit.cloneNode(true);
         spannode.appendChild(middleclone);
         middlebit.parentNode.replaceChild(spannode, middlebit);
         skip = 1;
       }
     }
     else if (node.nodeType == 1 && node.childNodes && !/(script|style)/i.test(node.tagName)) {
       // recurse into nodes except those matching script or style nodes
       for (var i = 0; i < node.childNodes.length; ++i) {
         i += applyWordClick(node.childNodes[i]);
       }
     }
     return skip;
   }
   applyWordClick(this); 
  });

  // Process WordClick clicks
  $('span.wc').bind('click', function() {
					
	// Apply a temporary style to selected term for word click
	$(this).addClass("selected");
	
	// Callback to ObjC to lookup the selected term
	window.location.href = "x-mw://lookup/" + $(this).text();
	
	// After a small delay, unselect the term
	$(this).delay(800);
	$(this).queue( function() {
	  $(this).removeClass("selected");
	  $(this).dequeue();
	});
	
	// Stop propogation and prevent default
	return false;

  });
});

// Called from objC, will show loading icon for audio and prevent additional clicks on this audio
function mwAudioStart(auID) {
  var auIDSelector = "#" + auID;
  if ( ! $(auIDSelector).hasClass("playing") )
    $(auIDSelector).addClass("playing").unbind('click');
};

// Called from objC, will show normal icon for audio, and install a click handler to play again
function mwAudioStop(auID) {
  var auIDSelector = "#" + auID;
  $(auIDSelector).removeClass("playing").click(function(e) {
    if ($(this).hasClass("au")) {
      // mark this element as playing and prevent further playback
      $(this).toggleClass("playing").unbind('click');
    }
    else {
      // disable any other behavior
      e.preventDefault();
    }
  });
};
